function im_new_label=cutting(im_label)
%Cette fonction spare les diffrentes rgions 
%en rgions connexes.

%Variables utilises
%last_new_label
%seed pour une rgion forme d'un point
%region_bd pour region before dilatation
%region_ad pour region after dilatation

%Fonctions en ligne
point2val=inline('sum(sum(point.*val))','point','val');
texte=ver('matlab');
if (str2num(texte.Version)<6)
  region_growing=inline('double(dilate(region,[0 1 0;1 1 1; 0 1 0])).*set','region','set');
else 
  region_growing=inline('imdilate(region,[0 1 0;1 1 1; 0 1 0]).*set','region','set');
end;

im_new_label=zeros(size(im_label));
last_new_label=0;
while (any(any(0==im_new_label)))
  seed=region_out(0==im_new_label); 
  set=(0==im_new_label).*(point2val(seed,im_label)==im_label);
  region_bd=seed;
  region_ad=region_growing(region_bd,set);
  while(any(any(region_ad~=region_bd)))
    region_bd=region_ad;
    region_ad=region_growing(region_bd,set);
  end;
  last_new_label=last_new_label+1;
  im_new_label=im_new_label+region_ad.*last_new_label;
end;

function [point,region2]=region_out(region1)
  hasard=rand(size(region1));
  point=(region1.*hasard==max(max(region1.*hasard)));
  region2=region1-point;
