function growing=growing_criterion(im,region1,point)
%La fonction criterion dcide si on fusionne les deux  rgions
%lorsque que l'cart-type de l'union de ces deux rgions est plus petite 
%que threshold.  im dsigne l'image.
%region est de mme taille que im et indique 
%la surface exacte de la rgion par des 1.

  global INIT_;
  if (1~=isfield(INIT_,'method_growing'))   initialisation;  end;

  threshold=INIT_.threshold_growing;

  if ('variance'==INIT_.method_growing)
    %Union de deux rgions
    region=(region1|point);
    %moyenne calcule sur une rgion
    mean_rg=inline('sum(sum(im.*region))/sum(sum(region))','im','region');
    value=mean_rg(im.^2,region)-(mean_rg(im,region))^2;
    %ANCIEN :
    %surface=sum(sum(region))/prod(size(im));
    %trade_off=value+0.03*surface^(1/3);
    growing=(value<=threshold);
  end;

  if ('diff_max'==INIT_.method_growing)
    %Union de deux rgions
    region=(region1|point);
     diff_max=inline('max(max(im.*region))-min(min((1-region)+im.*region))','im','region');
    if (diff_max(im,region)<threshold) growing=1; else growing=0; end;
  end;


function initialisation

  fprintf('Les mthodes peuvent tre \n');
  fprintf('variance\n');
  fprintf('diff_max\n');
  global INIT_;
  if (1~=isfield(INIT_,'method_growing'))
    INIT_.method_growing='variance';
  end;
  if (1~=isfield(INIT_,'threshold_growing'))
    INIT_.threshold_growing=0.02;
  end;
  INIT_,
  keyboard;
