function im_label=merge(im_label,im,threshold)
%La fonction split_merge calcule une image d'tiquettes im_label
%suivant l'algorithme de split and merge en fonction d'une image 
%en niveau de gris et d'un seuil threshold.
%Pour cela elle fait appelle  deux critres split_criterion et 
%merge_criterion auquel elle fait passer le paramtre threshold.
%
%  im_label=merge(im_label,im);

%Fonctions en ligne sur des listes d'attente
queue_not_empty=inline('~isempty(queue)','queue');
dequeue=inline('queue(2:end)','queue');
queue_peek=inline('queue(1)','queue');
thread_overflow=inline('size(thread.queue2,2)<=50','thread');

%%debug
%file_dbg=fopen('j:/t/rech_rq/seg_f8/log.txt','a+');
%fprintf(file_dbg,'\n merge.m\n %s',date);
%fprintf(file_dbg,'%d ',clock);
%fprintf(file_dbg,'\n');

%Cration du processus  partir de im_label
thread=thread_build;
queue_init=create_list(im_label);
 
while(queue_not_empty(queue_init))
  %suite de la cration du processus  partir de im_label
  while(queue_not_empty(queue_init)&(thread_overflow(thread)))
    thread=thread_in(thread,queue_peek(queue_init));
    queue_init=dequeue(queue_init);
  end;

  %Coeur du programme
  while(thread_not_empty(thread))
    [val1,val2,thread]=thread_out(thread);
    regionA=(im_label==val1);
    regionB=(im_label==val2);
    if ((isneighboor(regionA,regionB))&...
      (merge_criterion(im,regionA,regionB)))
      im_label=im_label+(im_label==val2)*(val1-val2);
      thread=thread_in(thread,val1);
      thread=thread_not_in(thread,val2);
    end;     
  end;

end;
list=thread_kill(thread);
%Ces lignes effectuent une renumrotation des tiquettes
new_list=(1:length(list));
cpt=1;
while(queue_not_empty(list))
  im_label_new=im_label+(cpt-queue_peek(list))*(im_label==queue_peek(list));
  list=dequeue(list);
end;
im_label=im_label_new;

%%debug
%  fclose(file_dbg);


function thread=thread_build
  thread.queue1=ones(1,0);
  thread.queue2=ones(2,0);

function [val1,val2,thread2]=thread_out(thread1)
  thread2.queue1=thread1.queue1;
  val1=thread1.queue2(1,1); val2=thread1.queue2(2,1);
  thread2.queue2=[thread1.queue2(1,2:end); thread1.queue2(2,2:end)];


function test=thread_not_empty(thread)
  test=(~isempty(thread.queue2));

function queue=thread_kill(thread);
%Cette fonction avertit qu'on ne doit plus utiliser le processus thread.
  queue=thread.queue1;

function thread=thread_in(thread,val)
%pour le fonctionnement de la fonction on a cr des fonctions en ligne
%se rapportant  la fois  thread.queue1 et  thread.queue2
  queue_sup=inline('queue(queue~=val)','queue','val');
  queue_no_val=...
    inline('sum(prod(queue==val*ones(1,size(queue,2)),1),2)==0','queue','val');
  dequeue=inline('queue(:,2:end)','queue');
  enqueue=inline('[queue val]','queue','val');
  queue_peek=inline('queue(:,1)','queue');
%Programme
%L'objectif est d'actualiser thread avec une nouvelle valeur
%La difficult est qu'on ne sait pas si cette valeur est dj prise
%Pour thread.queue1, on supprime la valeur si elle tait prsente 
%et on rajoute val
%Pour thread.queue2, on cr une queue intermdiaire qui contient tous 
%les couples que l'on peut former avec val et avec thread.queue1 sans val (tq1)
%Cette queue alimente ensuite thread.queue2  condition que les couples
%ne soient pas dj prsents dans thread.queue2.
%Calcul de thread.queue1
  if queue_no_val(thread.queue1,val) 
    thread.queue1=enqueue(thread.queue1,val);
  end;
%Calcul de thread.queue2
  tq1=queue_sup(thread.queue1,val);
  queue=[tq1.*(tq1<val)+ val*(tq1>val);
          val*(tq1<val)+tq1.*(tq1>val)];
  while(~isempty(queue))
    if (queue_no_val(thread.queue2,queue_peek(queue)))
      thread.queue2=enqueue(thread.queue2,queue_peek(queue));
    end;
    queue=dequeue(queue);
  end;

function thread2=thread_not_in(thread1,val)
%pour le fonctionnement de la fonction on a cr des fonctions en ligne
%se rapportant  la fois  thread.queue1 et  thread.queue2
  queue_sup=inline('queue(queue~=val)','queue','val');
  queue_build=[];
  dequeue=inline('queue(:,2:end)','queue');
  enqueue=inline('[queue val]','queue','val');
  queue_peek=inline('queue(:,1)','queue');
  queue_not_empty=inline('~isempty(queue)','queue');
%Programme
%Calcul de thread2.queue1
  thread2.queue1=queue_sup(thread1.queue1,val);
%Calcul de thread2.queue2
%On ne recopie sur thread1.queue2 que les lments n'ayant pas val
  thread2.queue2=queue_build;
  while(queue_not_empty(thread1.queue2))
    if (sum(queue_peek(thread1.queue2)==[val;val])==0)
      thread2.queue2=enqueue(thread2.queue2,queue_peek(thread1.queue2));
    end;
    thread1.queue2=dequeue(thread1.queue2);
  end;

function test=isneighboor(region1,region2)
%Deux rgions distinctes sont adjacentes
%si l'intersection d'une rgion tendue par la 4-connectivit
%et l'auter est non-vide, c'est--dire si le produit composante
%par composante est non-nulle.
%Cela s'applique qu' des rgions distinctes.
%On peut mettre un seuil sur la longueur de l'adjascence
%common_length (seuil sur la somme)
  common_length=2;
  texte=ver('matlab'); 
  if (str2num(texte.Version)<6)
    region2=double(dilate(region2,ones(3))); %Matlab 4
  else
    region2=double(imdilate(region2,ones(3))); %Matlab 6
  end;
  %pour les anciennes versions mettre dilate
  %ones(3) assure la dilatation dans toutes les directions
  %double assure de pouvoir faire des oprations arithmtiques sur les rgions
  test=(sum(sum(region1.*region2))>=common_length);

function list=create_list(matrix)
%Cette fonction cr une liste des valeurs prises par matrix  valeurs entires
  matrix=matrix(:);
  val_max=max(matrix);
  list=[];
  for val=0:val_max
    if (any(matrix==val)) list=[list val]; end;
  end;
