function im_label=merge5(im_label,im,threshold,adj)
%La fonction merge5 calcule une image d'tiquettes 
% partir d'une image en niveau de gris,
%d'une image d'tiquettes, d'un seuil, et 
%d'un graphe d'adjascence. 
%Le critre de fusion est la distance entre les deux pixels les plus proche
%et appartenant  chacune des deux rgions
%est infrieure  un certain seuil
%La fonction split_merge calcule une image d'tiquettes im_label
%suivant l'algorithme de split and merge en fonction d'une image 
%en niveau de gris et d'un seuil threshold.
%Pour cela elle fait appelle  deux critres split_criterion et 
%merge_criterion auquel elle fait passer le paramtre threshold.
%La fonction utilise aussi le graphe des liens d'adjascence
%indiqu par une matrice adj dont le nombre de ligne indique le 
%nombre de liens d'adjascence et la premire colonne indique 
%la premire tiquette et la deuxime colonne indique la deuxime 
%rgion adjascente
%Lorsqu'une rgion est fusionne avec une autre rgion, 
%cette nouvelle rgion est fusionne avec toutes les rgions
%qui taient adjacentes avec l'une ou l'autre des rgions
%
%  adj=imrag_(im_label);
%  im_label=merge5(im_label,im,threshold,adj);

%Thread est une structure de donnes qui 
%indique les couples de rgions susceptibles d'tre fusionnes
%Les fonctions qui accdent  thread sont 
%thread_build, thread_merge, thread_out, thread_not_empty

MinSet=inline('min(min(abs(unique(GA(:))*ones(1,length(unique(GB(:))))-ones(length(unique(GA(:))),1)*transpose(unique(GB(:))))))','GA','GB');

%Fonctions en ligne sur des listes d'attente
thread_debug=inline('[[thread.index size(thread.adj); zeros(1,3)] transpose(thread.adj(1:min(50,size(thread.adj,1)),:))]','thread');

%%debug
%file_dbg=fopen('j:/t/rech_rq/seg_f8/log.txt','a+');
%fprintf(file_dbg,'\n merge.m\n %s',date);
%fprintf(file_dbg,'%d ',clock);
%fprintf(file_dbg,'\n');

%Cration du processus  partir de im_label
thread=thread_build(adj);
 
%%DEBUG
%Fabrication d'un disque
%=meshgrid(-1:1/63.5:1); disc=(m.^2+(m.').^2<=0.5);
%Texture alatoire du disque
%imd=disc.*(0.6+0*randn(size(disc)));

%%DEBUG
%sur=inline('sum(sum(im==val))','im','val');
while(thread_not_empty(thread))
  [thread,val1,val2]=thread_out(thread);
%%DEBUG
%[val1 val2 sum(sum(im_label<=2)) sum(sum(im_label==3)) sum(sum(im_label==4)) sum(sum(im_label==5)) sum(sum(im_label>5))]
%if (sur(im_label,valb)>sur(im_label,vala)) val=vala; vala=valb; valb=val; end;
%if (sur(im_label,valb)>sur(im_label,val1)) valb=val1; end;
%[val1 val2 sur(im_label,val1) sur(im_label,val2) sum(sum((im_label~=val1).*(im_label~=val2)))],
  regionA=(im_label==val1);
  regionB=(im_label==val2);
%%DEBUG
%    figure(2); subplot(131); 
%    imshow(0.4-0.4*(im_label==val1)+0.4*(im_label==val2)+0.1*disc);
%    subplot(132); imshow(im_label==val1); subplot(133); imshow(im_label==val2);
%    figure(2); subplot(132), title([num2str(val1)]) 
%    figure(2); subplot(133), title([num2str(val2)]) 
%    [thread.adj(find(thread.adj(:,1)==val1),:); thread.adj(find(thread.adj(:,2)==val1),:)],)
  if (MinSet(im(regionA==1),im(regionB==1))<=threshold)
% if (abs(max(max(im.*(regionA|regionB)))-min(min(1-(regionA|regionB)+im.*(regionA|regionB))))<=threshold)
    im_label=im_label+(im_label==val2)*(val1-val2);
    thread=thread_merge(thread,val1,val2);
%%DEBUG
%    figure(2); subplot(131), title(['fusion ! ' num2str(thread.index)]),
%  else
%    figure(2); subplot(131), title(['non-fusion ' num2str(thread.index)]),
  end;  
  % im_label,
%  pause(0.01),
end;

%%debug
%  fclose(file_dbg);

function thread=thread_build(adj)
  thread.adj=adj;
  thread.index=1;

function test=thread_not_empty(thread)
  ind=thread.index;
  if (ind<=size(thread.adj))
    val1=thread.adj(ind,1);
    val2=thread.adj(ind,2);
    while((val1==val2)&(ind<size(thread.adj)))
      ind=ind+1;
      if (ind<=size(thread.adj))
        val1=thread.adj(ind,1);
        val2=thread.adj(ind,2);
      end;
    end;
  end;
  test=(ind<size(thread.adj,1));    

function [thread,val1,val2]=thread_out(thread)
  val1=thread.adj(thread.index,1);
  val2=thread.adj(thread.index,2);
  while(val1==val2)
   thread.index=thread.index+1;
   val1=thread.adj(thread.index,1);
   val2=thread.adj(thread.index,2);
  end;
  thread.index=thread.index+1;

function thread=thread_merge(thread,val1,val2)
  thread.adj(find(thread.adj(:,1)==val2),1)=val1;
  thread.adj(find(thread.adj(:,2)==val2),2)=val1;
  thread.adj=unique([thread.adj],'rows');
  thread.index=min(thread.index,min(find(thread.adj(:,1)==val1)));
