function merge=merge_criterion(im,region1,region2)
%La fonction criterion dcide si on fusionne les deux  rgions
%lorsque que l'cart-type de l'union de ces deux rgions est plus petite 
%que threshold.  im dsigne l'image.
%region est de mme taille que im et indique 
%la surface exacte de la rgion par des 1.

  global INIT_;
  if (1~=isfield(INIT_,'method_merge'))   initialisation;  end;

  threshold=INIT_.threshold_merge;

  if ('variance'==INIT_.method_merge)

  
    %Union de deux rgions
    region=region1+region2-region1.*region2;
    %moyenne calcule sur une rgion
    mean_rg=inline('sum(sum(im.*region))/sum(sum(region))','im','region');
    value=(mean_rg(im.^2,region)-(mean_rg(im,region))^2)^0.5;
    %ANCIEN
    %  surface=sum(sum(region))/prod(size(im));
    %  trade_off=value+0.03*surface^(1/3);
    merge=(value<=threshold);

  end;

  if ('diff_max'==INIT_.method_merge)
    %Union de deux rgions
    region=region1+region2-region1.*region2;
    diff_max=inline('max(max(im.*region))-min(min((1-region)+im.*region))','im','region');
    if (diff_max(im,region)<threshold) merge=1; else merge=0; end;
  end;


function initialisation

  fprintf('Les mthodes peuvent tre \n');
  fprintf('variance\n');
  fprintf('diff_max\n');
  global INIT_;
  if (1~=isfield(INIT_,'method_merge'))
    INIT_.method_merge='variance';
  end;
  if (1~=isfield(INIT_,'threshold_merge'))
    INIT_.threshold_merge=0.02;
  end;
  INIT_,
  keyboard;
