function im_label=split(im)
%La fonction split calcule une image d'tiquettes im_label
%suivant la premire partie de l'algorithme de split and merge
%Ceci se fait en fonction d'une image 
%en niveau de gris et d'un seuil threshold demand lors de la 
% premire utilisation.
%Pour cela elle fait appel  un critre split_criterion 
%auquel elle fait passer le paramtre threshold.
%
%  im_label=split(im);


  queue_build=[];
  enqueue=inline('[queue val]','queue','val');
  dequeue=inline('queue(2:end)','queue');
  queue_peek=inline('queue(1)','queue');
  queue_not_empty=inline('~isempty(queue)','queue');
  queue_not_overflow=inline('length(queue)<1000','queue');


%Programme principal

  label=label_init(size(im));
  queue=enqueue(queue_build,1);
  while ((queue_not_empty(queue))&(queue_not_overflow(queue)))
    if (split_criterion(im,label.im==queue_peek(queue)))
      [label,queue]=label_split(label,queue);
    else queue=dequeue(queue);
    end;

  end;
  %label_debug(label,queue), 
  clear queue;
  im_label=label.im;


function label=label_init(size_)
%On initialise l'image d'tiquettes avec une seule tiquette.
  label.im=ones(size_); 
  label.last=1;

function [label,queue]=label_split(label,queue)  
%Cette fonction dcoupe en quatre la rgion d'tiquette label.ind
%Elle donne les tiquettes length(label.list)+1,+2,+3
%aux trois rgions suivantes.
%Cette fonction indique aussi si les rgions sont suffisemment 
%grandes pour tre encore dcoupes, cela est indiqu sur 
%la deuxime ligne de 'label.list'.
%
%Implmentation de la queue
  enqueue=inline('[queue val]','queue','val');
  dequeue=inline('queue(2:end)','queue');
  queue_peek=inline('queue(1)','queue');
%
%Rectangle contenant la rgion
% Cette fonction dtermine les indices du rectangle contenant 
% la rgion tudie ainsi que les indices du milieu de cette rgion
  sq=region2square(label.im==queue_peek(queue));
%
%Nouvelles attributions
  label.last=label.last;
  label.im(sq.up:sq.mv,(sq.mh+1):sq.right)      =label.last+1;
  label.im((sq.mv+1):sq.down,sq.left:sq.mh)     =label.last+2;
  label.im((sq.mv+1):sq.down,(sq.mh+1):sq.right)=label.last+3;
%Contrle des tailles
  size_min=2;
  check_size(1)=((sq.mv-sq.up+1>=size_min)&(sq.mh-sq.left+1>=size_min));
  check_size(2)=((sq.mv-sq.up+1>=size_min)&(sq.right-sq.mh>=size_min));
  check_size(3)=((sq.down-sq.mv>=size_min)&(sq.mh-sq.left+1>=size_min));
  check_size(4)=((sq.down-sq.mv>=size_min)&(sq.right-sq.mh>=size_min));
%Manipulation de la queue, 
%on teste ici si ces rgions devront tre  leur tour diviss.
  if (0==check_size(1)) queue=dequeue(queue);             end;
  if (check_size(2))    queue=enqueue(queue,label.last+1); end;
  if (check_size(3))    queue=enqueue(queue,label.last+2); end;
  if (check_size(4))    queue=enqueue(queue,label.last+3); end;
%Incrmentation de la dernire tiquette
  label.last=label.last+3;

function label_debug(label,queue)
  queue, 
  [queue_peek(queue), length(queue), label.last],
  imshow(label.im/max(label.im(:)));
  pause;

function square=region2square(region)
%Cette fonction dtermine les indices du rectangle contenant 
%la rgion tudie ainsi que les indices du milieu de cette rgion
  I=size(region,1); J=size(region,2);
  [j,i]=meshgrid(1:J,1:I);
  %Indices du rectangle
  square.left=1+J+min(min((j-J-1).*region));
  square.right=max(max(j.*(region)));
  square.up=1+I+min(min((i-I-1).*region));
  square.down=max(max(i.*(region)));
  %Milieux du carr
  square.mh=square.left+round((1+square.right-square.left)/2)-1;
  square.mv=square.up+round((1+square.down-square.up)/2)-1;
  
