function split=split_criterion(im,region)
%La fonction criterion dcide si on dcoupe la rgion
%lorsque que l'cart-type de cette rgion est plus important 
%que threshold.  im dsigne l'image ou une portion rectangulaire de celle-ci.
%region est de mme taille que im et indique 
%la surface exacte de la rgion par des 1.


  global INIT_;
  if (1~=isfield(INIT_,'method_split'))   initialisation;  end;

  threshold=INIT_.threshold_split;

  if ('variance'==INIT_.method_split)
    %moyenne calcule sur une rgion
    mean_rg=inline('sum(sum(im.*region))/sum(sum(region))','im','region');
    value=mean_rg(im.^2,region)-(mean_rg(im,region))^2;
    %ANCIEN : 
    %surface=sum(sum(im.*region))/prod(size(im));
    %trade=value+0.03*surface^(1/3);
    if (value>threshold) split=1; else split=0; end;
  end;

  if ('diff_max'==INIT_.method_split)
    diff_max=inline('max(max(im.*region))-min(min((1-region)+im.*region))','im','region');
    if (diff_max(im,region)>threshold) split=1; else split=0; end;
  end;


function initialisation

  fprintf('Les mthodes peuvent tre \n');
  fprintf('variance\n');
  fprintf('diff_max\n');
  global INIT_;
  if (1~=isfield(INIT_,'method_split'))
    INIT_.method_split='variance';
  end;
  if (1~=isfield(INIT_,'threshold_split'))
    INIT_.threshold_split=0.02;
  end;
  INIT_,
  keyboard;
